
/****** Object : Table [dbo].[SnmpTemp] Copyright TECK SYSTEM SOFT 2015 ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [OID] = '' WHERE [OID] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Subject] = '' WHERE [Subject] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Value] = '' WHERE [Value] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] SET [Availability] = '' WHERE [Availability] IS NULL

INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
	  ,[OID]
      ,[Subject]
      ,[Value] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)

SELECT  
GETDATE()
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
	   ,[OID]
      ,[Subject]
      ,[Value] 
      ,[Mode] 
      ,[Alarm]
      ,CONVERT(nvarchar(10),[Availability])

FROM

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] +  '-' + [OID] + '-' + [Subject] +  '-' + [Value] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	   /*,[Insert_Date] Add for test purpose only */
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
       ,[OID]
	  ,[Subject]
      ,[Value] 
      ,[Mode]
      ,[Alarm]
      ,[Availability]  

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp]
WHERE [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] +  '-' + [OID]  + '-' + [Subject] +  '-' + [Value] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] +  '-' + [OID]  + '-' + [Subject] +  '-' + [Value] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  as SEARCH_STRING 
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] 
SET  [Value] = REQUEST.[Value],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability],
     [Insert_Date] = REQUEST.[Insert_Date]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SNMP,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Snmp_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[OID],
TEMP_JOIN.[Subject],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Value],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND 
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Subject] =  TEMP_JOIN .[Subject] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Value] = TEMP_JOIN .[Value] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Snmp_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[OID],
TEMP_JOIN.[Subject],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Value],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Snmp_ID) = TEMP_JOIN.[Snmp_ID]) AS REQUEST

WHERE
SNMP.[Customer] = REQUEST.[Customer]
AND SNMP.[Site] = REQUEST.[Site]
AND SNMP.[Domain] = REQUEST.[Domain]
AND SNMP.[Computer] = REQUEST.[Computer]
AND SNMP.[Alarm] = REQUEST.[Alarm]
AND SNMP.[Value] = REQUEST.[Value]
AND SNMP.[Availability] = REQUEST.[Availability]
   

/****** Object : Clean Temporary SQL Table ******/

 /*TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp] */
